---
 abi-tags                    |    2 +-
 configure                   |    6 +++---
 configure.in                |    6 +++---
 linuxthreads/shlib-versions |    3 ++-
 shlib-versions              |    4 ++++
 5 files changed, 13 insertions(+), 8 deletions(-)

--- a/abi-tags
+++ b/abi-tags
@@ -22,7 +22,7 @@
 
 .*-sun-solaris2.*	2	2.0.0	# just an arbitrary value
 
-.*-.*-freebsd.*-gnu.*	3	4.0.0	# earliest compatible kernel version
+.*-.*-kfreebsd.*	3	5.4.0	# earliest compatible kernel version
 
 .*-.*-knetbsd.*-gnu.*	4	1.6.0	# earliest compatible kernel version
 
--- a/configure
+++ b/configure
@@ -2282,7 +2282,7 @@
 # i586-linuxaout is mangled into i586-pc-linux-gnuaout
 linux*ecoff* | linux*aout* | gnu*aout* | gnu*ecoff*)
   ;;
-gnu* | linux* | freebsd* | netbsd* | sysv4* | solaris2* | irix6*)
+gnu* | linux* | freebsd* | netbsd* | k*bsd* | sysv4* | solaris2* | irix6*)
   # These systems (almost) always use the ELF format.
   elf=yes
   ;;
@@ -2489,7 +2489,7 @@
 ###
 if test -z "$enable_hacker_mode" && test x"$libc_config_ok" != xyes; then
   case "$machine-$host_os" in
-  *-linux* | *-gnu* | arm*-none* | powerpc-aix4.3.*)
+  *-linux* | *-gnu* | *-kfreebsd* | arm*-none* | powerpc-aix4.3.*)
     ;;
   *)
     echo "*** The GNU C library is currently not available for this platform."
@@ -2563,7 +2563,7 @@
 test "x$base_os" != x || case "$os" in
 gnu*)
   base_os=mach/hurd ;;
-netbsd* | 386bsd* | freebsd* | bsdi*)
+netbsd* | 386bsd* | freebsd* | bsdi* | k*bsd*)
   base_os=unix/bsd/bsd4.4 ;;
 osf* | sunos* | ultrix* | newsos* | dynix* | *bsd*)
   base_os=unix/bsd ;;
--- a/configure.in
+++ b/configure.in
@@ -283,7 +283,7 @@
 # i586-linuxaout is mangled into i586-pc-linux-gnuaout
 linux*ecoff* | linux*aout* | gnu*aout* | gnu*ecoff*)
   ;;
-gnu* | linux* | freebsd* | netbsd* | sysv4* | solaris2* | irix6*)
+gnu* | linux* | freebsd* | netbsd* | k*bsd* | sysv4* | solaris2* | irix6*)
   # These systems (almost) always use the ELF format.
   elf=yes
   ;;
@@ -469,7 +469,7 @@
 ###
 if test -z "$enable_hacker_mode" && test x"$libc_config_ok" != xyes; then
   case "$machine-$host_os" in
-  *-linux* | *-gnu* | arm*-none* | powerpc-aix4.3.*)
+  *-linux* | *-gnu* | *-kfreebsd* | arm*-none* | powerpc-aix4.3.*)
     ;;
   *)
     echo "*** The GNU C library is currently not available for this platform."
@@ -544,7 +544,7 @@
 test "x$base_os" != x || case "$os" in
 gnu*)
   base_os=mach/hurd ;;
-netbsd* | 386bsd* | freebsd* | bsdi*)
+netbsd* | 386bsd* | freebsd* | bsdi* | k*bsd*)
   base_os=unix/bsd/bsd4.4 ;;
 osf* | sunos* | ultrix* | newsos* | dynix* | *bsd*)
   base_os=unix/bsd ;;
--- a/shlib-versions
+++ b/shlib-versions
@@ -31,6 +31,7 @@
 x86_64-.*-linux.*       DEFAULT			GLIBC_2.2.5
 powerpc64-.*-linux.*	DEFAULT			GLIBC_2.3
 .*-.*-gnu-gnu.*		DEFAULT			GLIBC_2.2.6
+.*-.*-kfreebsd.*	DEFAULT			GLIBC_2.3
 
 # Configuration		WORDSIZE[32|64]		Alternate configuration
 # -------------		----------		-----------------------
@@ -53,6 +54,7 @@
 sh.*-.*-linux.*		libm=6			GLIBC_2.2
 .*-.*-linux.*		libm=6
 .*-.*-gnu-gnu.*		libm=6
+.*-.*-kfreebsd.*	libm=1
 
 # We provide libc.so.6 for Linux kernel versions 2.0 and later.
 alpha.*-.*-linux.*	libc=6.1
@@ -60,6 +62,7 @@
 sh.*-.*-linux.*		libc=6			GLIBC_2.2
 sparc64.*-.*-linux.*	libc=6			GLIBC_2.2
 .*-.*-linux.*		libc=6
+.*-.*-kfreebsd.*	libc=0.1
 
 # libmachuser.so.1 corresponds to mach/*.defs as of Utah's UK22 release.
 .*-.*-gnu-gnu.*		libmachuser=1
@@ -81,6 +84,7 @@
 powerpc64.*-.*-linux.*	ld=ld64.so.1		GLIBC_2.3
 cris-.*-linux.*		ld=ld.so.1		GLIBC_2.2
 x86_64-.*-linux.*	ld=ld-linux-x86-64.so.2	GLIBC_2.2.5
+x86_64-.*-kfreebsd.*	ld=ld-kfreebsd-x86-64.so.1
 # We use the ELF ABI standard name for the default.
 .*-.*-.*		ld=ld.so.1
 
--- a/linuxthreads/shlib-versions
+++ b/linuxthreads/shlib-versions
@@ -8,4 +8,5 @@
 cris-.*-linux.*		libpthread=0		GLIBC_2.2
 x86_64-.*-linux.*	libpthread=0		GLIBC_2.2.5
 powerpc64-.*-linux.*	libpthread=0		GLIBC_2.3
-.*-.*-linux.*		libpthread=0
+.*-.*-kfreebsd.*	libpthread=0		GLIBC_2.3
+.*-.*-.*		libpthread=0
--- a/linuxthreads_db/shlib-versions
+++ b/linuxthreads_db/shlib-versions
@@ -1,2 +1,3 @@
 # The thread debug library
 .*-.*-linux.*		libthread_db=1
+.*-.*-kfreebsd.*	libthread_db=1
